/********************************************************************************************
**
**	File:	Init_PLL.c
**	Date:	9-3-04
**	Author:	BM
**	Use:	Initialize the DSP PLL for the required CCLK and HCLK rates
**	Note:	
**		CLKIN will be 24.576MHz from an external oscillator.  The PLL is programmed 
**		to generate a core clock (CCLK) of 330.7MHz - PLL multiplier = 0x001B and 
**		divider = 0x02.
**
**
*********************************************************************************************/
#include    <tt.h>
int i;

void InitPLL(){

/********************************************************************************************/
// Enable Test 1 or Test 2 as required.
//24.576 MHz CLKIN
//(24.576MHz * 27) /2 = 331.776 MHz

//No need to put in bypass for DIVEN
//the change may be made the fly, and divisor enable can be done in same write to pmctl
//Divide the input by 2
*pPMCTL |= (DIVEN|BIT_6);

//Clear the Multiplier
*pPMCTL &= ~(INDIV|0x3f);
*pPMCTL |= (PLLM27|PLLBP); 

*pPMCTL |= (PLLM27 | PLLBP); //divide by two by default

for(i = 0 ; i <= 4096 ; i++) //wait for PLL to lock at new rate
	asm("nop;");

*pPMCTL &= ~(PLLBP);	//out of bypass
*pPMCTL |= (CLKOUTEN); 	//and start clkout
}
